"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParsableArbitratorCert = exports.ParsableKycCert = exports.ParsableOffer = exports.ParsableTrade = exports.ParsableMarketState = exports.ParsableConfig = void 0;
const anchor_1 = require("@project-serum/anchor");
const types_1 = require("../types");
let ParsableConfig = class ParsableConfig {
    constructor() { }
    static parse(data) {
        if (!data) {
            return null;
        }
        try {
            return parseAnchorAccount(types_1.AccountName.EscrowConfig, data);
        }
        catch (e) {
            console.error(`error while parsing WhirlpoolsConfig: ${e}`);
            return null;
        }
    }
};
ParsableConfig = __decorate([
    staticImplements()
], ParsableConfig);
exports.ParsableConfig = ParsableConfig;
let ParsableMarketState = class ParsableMarketState {
    constructor() { }
    static parse(data) {
        if (!data) {
            return null;
        }
        try {
            return parseAnchorAccount(types_1.AccountName.MarketState, data);
        }
        catch (e) {
            console.error(`error while parsing WhirlpoolsConfig: ${e}`);
            return null;
        }
    }
};
ParsableMarketState = __decorate([
    staticImplements()
], ParsableMarketState);
exports.ParsableMarketState = ParsableMarketState;
let ParsableTrade = class ParsableTrade {
    constructor() { }
    static parse(data) {
        if (!data) {
            return null;
        }
        try {
            return parseAnchorAccount(types_1.AccountName.Trade, data);
        }
        catch (e) {
            console.error(`error while parsing TradeOder: ${e}`);
            return null;
        }
    }
};
ParsableTrade = __decorate([
    staticImplements()
], ParsableTrade);
exports.ParsableTrade = ParsableTrade;
let ParsableOffer = class ParsableOffer {
    constructor() { }
    static parse(data) {
        if (!data) {
            return null;
        }
        try {
            return parseAnchorAccount(types_1.AccountName.Offer, data);
        }
        catch (e) {
            console.error(`error while parsing Offer: ${e}`);
            return null;
        }
    }
};
ParsableOffer = __decorate([
    staticImplements()
], ParsableOffer);
exports.ParsableOffer = ParsableOffer;
let ParsableKycCert = class ParsableKycCert {
    constructor() { }
    static parse(data) {
        if (!data) {
            return null;
        }
        try {
            return parseAnchorAccount(types_1.AccountName.KycCert, data);
        }
        catch (e) {
            console.error(`error while parsing KYC Cert: ${e}`);
            return null;
        }
    }
};
ParsableKycCert = __decorate([
    staticImplements()
], ParsableKycCert);
exports.ParsableKycCert = ParsableKycCert;
let ParsableArbitratorCert = class ParsableArbitratorCert {
    constructor() { }
    static parse(data) {
        if (!data) {
            return null;
        }
        try {
            return parseAnchorAccount(types_1.AccountName.ArbitratorCert, data);
        }
        catch (e) {
            console.error(`error while parsing KYC Cert: ${e}`);
            return null;
        }
    }
};
ParsableArbitratorCert = __decorate([
    staticImplements()
], ParsableArbitratorCert);
exports.ParsableArbitratorCert = ParsableArbitratorCert;
/**
 * Class decorator to define an interface with static methods
 * Reference: https://github.com/Microsoft/TypeScript/issues/13462#issuecomment-295685298
 */
function staticImplements() {
    return (constructor) => {
        constructor;
    };
}
function parseAnchorAccount(accountName, data) {
    const discriminator = anchor_1.BorshAccountsCoder.accountDiscriminator(accountName);
    if (discriminator.compare(data.slice(0, 8))) {
        console.error("incorrect account name during parsing");
        return null;
    }
    try {
        return types_1.ESCROW_CODER.decode(accountName, data);
    }
    catch (_e) {
        console.error("unknown account name during parsing");
        return null;
    }
}
