/// <reference types="bn.js" />
import { Instruction } from "@orca-so/common-sdk";
import { PublicKey } from "@solana/web3.js";
import { Program, BN } from "@project-serum/anchor";
import { Escrow } from "../artifacts/escrow";
export type UpdateMarketParams = {
    marketAccount: PublicKey;
    tradeConfigAuthority: PublicKey;
    treasuryPubkey: PublicKey | null;
    bondSize: BN | null;
    arbitratorCommission: BN | null;
    treasuryShare: BN | null;
    paymentDuration: BN | null;
    cancelPenaltyRate: BN | null;
    limitActiveBondlessTrade: number | null;
};
export declare function updateMarket(program: Program<Escrow>, params: UpdateMarketParams): Promise<Instruction>;
