import * as anchor from "@project-serum/anchor";
import { PublicKey } from "@solana/web3.js";
export interface PDAInfo {
    key: anchor.web3.PublicKey;
    bump: number;
}
export declare class PDA {
    readonly programId: anchor.web3.PublicKey;
    readonly marketId: string;
    readonly configId: string;
    constructor(programId: anchor.web3.PublicKey, configId: string, marketId: string);
    getConfigPDA: () => PDAInfo;
    getMarketPDA: (tokenMint: PublicKey) => PDAInfo;
    getMarketTokenVaultPDA: (tokenMint: PublicKey) => PDAInfo;
    getMarketNativeVaultPDA: (tokenMint: PublicKey) => PDAInfo;
    getOfferPDA: (offerID: anchor.BN) => PDAInfo;
    getTradePDA: (tradeID: anchor.BN) => PDAInfo;
    getArbitratorCertPDA: (arbitratorAuthority: anchor.web3.PublicKey, tokenMint: PublicKey) => PDAInfo;
    getKycCertPDA: (user: anchor.web3.PublicKey, tokenMint: PublicKey) => PDAInfo;
    getEvidencePDA: (user: anchor.web3.PublicKey, trade: anchor.web3.PublicKey) => PDAInfo;
}
