import { PublicKey } from "@solana/web3.js";
import { TradeDataInfo as TradeDataInfoV2, OfferDataInfo as OfferDataInfoV2 } from "../../index";
export declare enum Version {
    V0 = "V0",
    V1 = "V1"
}
export type ITradeDataInfo = TradeDataInfoV2 & {
    version: Version;
    tokenVault: PublicKey;
    nativeVault: PublicKey;
};
export type IOfferDataInfo = OfferDataInfoV2 & {
    version: Version;
};
export declare const ITradeState: {
    Awaiting: {
        awaiting: {};
    };
    Deposited: {
        deposited: {};
    };
    Disputed: {
        disputed: {};
    };
    Released: {
        released: {};
    };
    Canceled: {
        canceled: {};
    };
};
export declare const IDisputeAction: {
    Release: {
        release: {};
    };
    Cancel: {
        cancel: {};
    };
};
export declare const ICompensationAction: {
    NoCompensate: {
        noCompensate: {};
    };
    CompensateSeller: {
        compensateSeller: {};
    };
    CompensateBuyer: {
        compensateBuyer: {};
    };
};
