"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getContextV1 = exports.getContextV0 = void 0;
const escrow_sdk_v0_1 = require("escrow-sdk-v0");
const index_1 = require("../../index");
const anchor_1 = require("@project-serum/anchor");
const getContextV0 = (connection, wallet, programId) => {
    const commitment = "confirmed";
    const provider = new anchor_1.AnchorProvider(connection, wallet, { commitment });
    const ctx = escrow_sdk_v0_1.EscrowContext.withProvider(provider, programId);
    return ctx;
};
exports.getContextV0 = getContextV0;
const getContextV1 = (connection, wallet, programId) => {
    const commitment = "confirmed";
    const provider = new anchor_1.AnchorProvider(connection, wallet, { commitment });
    const ctx = index_1.EscrowContext.withProvider(provider, programId);
    return ctx;
};
exports.getContextV1 = getContextV1;
