"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.convertQ32x32ToNumber = exports.convertNumberToQ32x32 = exports.getRemaningAccounts = exports.getTokenRateOverUsd = exports.getUsdRate = exports.getTokenRateOverRenec = exports.getRenecRate = exports.DEFAULT_EXPO = exports.DENOMINATOR = void 0;
const decimal_js_1 = __importDefault(require("decimal.js"));
const common_sdk_1 = require("@orca-so/common-sdk");
const web3_js_1 = require("@solana/web3.js");
const anchor_1 = require("@project-serum/anchor");
__exportStar(require("./kyc-cert"), exports);
__exportStar(require("./offer"), exports);
__exportStar(require("./encrypt-decrypt"), exports);
__exportStar(require("./consts"), exports);
exports.DENOMINATOR = 10000;
exports.DEFAULT_EXPO = 9;
const getRenecRate = (marketStateData) => {
    const renecRate = common_sdk_1.DecimalUtil.fromU64(marketStateData.tokenMetadata.renecRate, marketStateData.tokenDecimals);
    return renecRate;
};
exports.getRenecRate = getRenecRate;
const getTokenRateOverRenec = (tokenRateInRenec) => {
    const renecRate = common_sdk_1.DecimalUtil.fromU64(tokenRateInRenec).div(web3_js_1.LAMPORTS_PER_SOL).pow(-1);
    return renecRate;
};
exports.getTokenRateOverRenec = getTokenRateOverRenec;
const getUsdRate = (usdRate) => {
    const renecRate = common_sdk_1.DecimalUtil.fromU64(usdRate, 9);
    return renecRate;
};
exports.getUsdRate = getUsdRate;
const getTokenRateOverUsd = (tokenRateInUsd) => {
    const renecRate = common_sdk_1.DecimalUtil.fromU64(tokenRateInUsd).div(web3_js_1.LAMPORTS_PER_SOL).pow(-1);
    return renecRate;
};
exports.getTokenRateOverUsd = getTokenRateOverUsd;
const getRemaningAccounts = (accounts) => {
    let remainingAccounts = [];
    for (let i = 0; i < accounts.length; i++) {
        remainingAccounts.push({
            isSigner: false,
            isWritable: true,
            pubkey: accounts[i],
        });
    }
    return remainingAccounts;
};
exports.getRemaningAccounts = getRemaningAccounts;
const convertNumberToQ32x32 = (number) => {
    return new anchor_1.BN(new decimal_js_1.default(number).mul(new decimal_js_1.default(2).pow(32)).floor().toString());
};
exports.convertNumberToQ32x32 = convertNumberToQ32x32;
const convertQ32x32ToNumber = (q32x32) => {
    return new decimal_js_1.default(q32x32.toString()).div(new decimal_js_1.default(2).pow(32)).toNumber();
};
exports.convertQ32x32ToNumber = convertQ32x32ToNumber;
